'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./styles.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var monthArray = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];

var DatePicker = function (_Component) {
  _inherits(DatePicker, _Component);

  function DatePicker(props) {
    _classCallCheck(this, DatePicker);

    var _this = _possibleConstructorReturn(this, (DatePicker.__proto__ || Object.getPrototypeOf(DatePicker)).call(this, props));

    _this.componentDidMount = function () {
      var currentDate = new Date();

      if (_this.props.defaultDate) {
        var splitDate = _this.props.defaultDate.split('/');
        var stdDateFormat = splitDate[1] + '/' + splitDate[0] + '/' + splitDate[2];
        currentDate = new Date(stdDateFormat);
      }

      var month = currentDate.getMonth();
      var day = currentDate.getDate();
      var year = currentDate.getFullYear();

      _this.setState({
        selectedDate: _this.props.defaultDate ? _this.props.defaultDate : day + '/' + (month + 1) + '/' + year,
        selectedDay: day,
        selectedMonth: month,
        selectedYear: year
      });
    };

    _this.daysInMonth = function (month, year) {
      return 32 - new Date(year, month, 32).getDate();
    };

    _this.hidePopup = function () {
      _this.setState({
        showPopup: !_this.state.showPopup,
        showDatePicker: true,
        showMonthPicker: false,
        showYearPicker: false
      });
    };

    _this.onDateSelect = function (evt) {
      var _this$state = _this.state,
          selectedMonth = _this$state.selectedMonth,
          selectedYear = _this$state.selectedYear;

      var day = parseInt(evt.target.innerText, 10);

      _this.setState({
        selectedDay: day,
        selectedDate: day + '/' + (selectedMonth + 1) + '/' + selectedYear
      });
      _this.hidePopup();
    };

    _this.onMonthSelect = function (evt) {
      var _this$state2 = _this.state,
          selectedDay = _this$state2.selectedDay,
          selectedYear = _this$state2.selectedYear;

      var month = evt.target.innerText;
      var monthIndex = monthArray.findIndex(function (item) {
        return item.includes(month);
      });
      _this.setState({
        selectedMonth: monthIndex,
        selectedDate: selectedDay + '/' + (monthIndex + 1) + '/' + selectedYear,
        showMonthPicker: false,
        showDatePicker: true
      });
    };

    _this.onYearSelect = function (evt) {
      var _this$state3 = _this.state,
          selectedDay = _this$state3.selectedDay,
          selectedMonth = _this$state3.selectedMonth;

      var year = parseInt(evt.target.innerText, 10);

      _this.setState({
        selectedYear: year,
        selectedDate: selectedDay + '/' + (selectedMonth + 1) + '/' + year,
        showYearPicker: false,
        showDatePicker: true
      });
    };

    _this.onPrevMonthClick = function () {
      var _this$state4 = _this.state,
          selectedMonth = _this$state4.selectedMonth,
          selectedYear = _this$state4.selectedYear;

      var month = 0;
      var year = selectedYear;

      if (selectedMonth === 0) {
        month = 11;
        year = selectedYear - 1;
      } else {
        month = selectedMonth - 1;
      }
      _this.setState({
        selectedYear: year,
        selectedMonth: month
      });
    };

    _this.onNextMonthClick = function () {
      var _this$state5 = _this.state,
          selectedMonth = _this$state5.selectedMonth,
          selectedYear = _this$state5.selectedYear;

      var month = 0;
      var year = selectedYear;

      if (selectedMonth === 11) {
        month = 0;
        year = selectedYear + 1;
      } else {
        month = selectedMonth + 1;
      }
      _this.setState({
        selectedYear: year,
        selectedMonth: month
      });
    };

    _this.onMonthPickerSelect = function () {
      _this.setState({
        showYearPicker: false,
        showMonthPicker: true,
        showDatePicker: false
      });
    };

    _this.onYearPickerSelect = function () {
      _this.setState({
        showYearPicker: true,
        showMonthPicker: false,
        showDatePicker: false
      });
    };

    _this.state = {
      showPopup: false,
      showDatePicker: true,
      showMonthPicker: false,
      showYearPicker: false,
      selectedDate: '',
      selectedDay: 0,
      selectedMonth: 0,
      selectedYear: 0
    };
    return _this;
  }

  _createClass(DatePicker, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _state = this.state,
          showYearPicker = _state.showYearPicker,
          showMonthPicker = _state.showMonthPicker,
          showDatePicker = _state.showDatePicker,
          selectedDate = _state.selectedDate,
          selectedDay = _state.selectedDay,
          selectedMonth = _state.selectedMonth,
          selectedYear = _state.selectedYear,
          showPopup = _state.showPopup;


      var monthDays = this.daysInMonth(selectedMonth, selectedYear);
      var startDay = new Date(selectedMonth + 1 + '/1/' + selectedYear).getDay();
      var dateArray = [];
      dateArray = new Array(42).fill(null);
      for (var index = startDay, startDate = 1; startDate <= monthDays; index += 1, startDate += 1) {
        dateArray[index] = startDate;
      }

      var yearArray = Array.from(Array(12), function () {
        var year = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : selectedYear - 5;
        var i = arguments[1];
        return year + i;
      });

      return _react2.default.createElement(
        'div',
        { className: 'date-picker-wrapper' },
        _react2.default.createElement(
          'div',
          {
            className: 'date-picker-selector',
            onClick: function onClick() {
              return _this2.hidePopup();
            },
            role: 'presentation'
          },
          selectedDate
        ),
        showPopup && _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(
            'div',
            { className: 'date-picker-popup' },
            _react2.default.createElement(
              'div',
              { className: 'arrow-up' },
              _react2.default.createElement('div', { className: 'inner-triangle' })
            ),
            _react2.default.createElement(
              'div',
              { className: 'title-wrapper' },
              _react2.default.createElement(
                'span',
                null,
                _react2.default.createElement(
                  'span',
                  {
                    onClick: function onClick() {
                      return _this2.onMonthPickerSelect();
                    },
                    role: 'presentation'
                  },
                  monthArray[selectedMonth]
                ),
                _react2.default.createElement(
                  'span',
                  {
                    onClick: function onClick(evt) {
                      return _this2.onYearPickerSelect(evt);
                    },
                    role: 'presentation'
                  },
                  '  ' + selectedYear
                )
              ),
              _react2.default.createElement(
                'div',
                { className: 'arrow-wrapper' },
                _react2.default.createElement('div', {
                  className: 'left-arrow',
                  onClick: function onClick() {
                    return _this2.onPrevMonthClick();
                  },
                  role: 'presentation'
                }),
                _react2.default.createElement('div', {
                  className: 'right-arrow',
                  onClick: function onClick() {
                    return _this2.onNextMonthClick();
                  },
                  role: 'presentation'
                })
              )
            ),
            showDatePicker && _react2.default.createElement(
              'div',
              null,
              _react2.default.createElement(
                'div',
                { className: 'week-name-wrapper' },
                _react2.default.createElement(
                  'tr',
                  null,
                  _react2.default.createElement(
                    'td',
                    null,
                    'Su'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'Mo'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'Tu'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'We'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'Th'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'Fr'
                  ),
                  _react2.default.createElement(
                    'td',
                    null,
                    'Sa'
                  )
                )
              ),
              _react2.default.createElement(
                'div',
                { className: 'date-wrapper' },
                dateArray.map(function (date) {
                  return _react2.default.createElement(
                    'div',
                    {
                      onClick: function onClick(evt) {
                        return _this2.onDateSelect(evt);
                      },
                      role: 'presentation',
                      className: date !== null ? 'date-item ' + (date === selectedDay && 'selected-date-item') : 'date-space'
                    },
                    date
                  );
                })
              )
            ),
            showMonthPicker && _react2.default.createElement(
              'div',
              { className: 'month-wrapper' },
              monthArray.map(function (month, index) {
                return _react2.default.createElement(
                  'div',
                  {
                    onClick: function onClick(evt) {
                      return _this2.onMonthSelect(evt);
                    },
                    role: 'presentation',
                    className: 'month-item ' + (index === selectedMonth && 'selected-date-item')
                  },
                  month.substring(0, 3)
                );
              })
            ),
            showYearPicker && _react2.default.createElement(
              'div',
              { className: 'year-wrapper' },
              yearArray.map(function (year) {
                return _react2.default.createElement(
                  'div',
                  {
                    onClick: function onClick(evt) {
                      return _this2.onYearSelect(evt);
                    },
                    role: 'presentation',
                    className: 'year-item ' + (year === selectedYear && 'selected-date-item')
                  },
                  year
                );
              })
            )
          )
        )
      );
    }
  }]);

  return DatePicker;
}(_react.Component);

;

DatePicker.propTypes = {
  defaultDate: _propTypes2.default.string
};

DatePicker.defaultProps = {
  defaultDate: ''
};

exports.default = DatePicker;